#include <stdio.h>
#include "FilesInDir.h"

FilesInDir::FilesInDir (string & Dirname, MountArray * Mtlist)
{
	DirectoryOpened = Dirname;
	if ((Dir = opendir (Dirname.c_str ())) == NULL) {
		string error ("Unable to open Directory ");

		error += Dirname;
		perror (error.c_str ());
		open = FALSE;
	} else
		open = TRUE;
	MntList = Mtlist;
}

FilesInDir::FilesInDir (string & Dirname)
{
	DirectoryOpened = Dirname;
	if ((Dir = opendir (Dirname.c_str ())) == NULL) {
		string error ("Unable to open Directory ");

		error += Dirname;
		perror (error.c_str ());
		open = FALSE;
	} else
		open = TRUE;
	MntList = NULL;
}

int FilesInDir::CountDirs ()
{
	int CountDirs = 0;

	while (NULL != (DirentStruct = readdir (Dir))) {
		string EntryName (DirentStruct->d_name);

		if ((EntryName == ".") || (EntryName == ".."))
			continue;
		string fp;

		if (DirectoryOpened != "/")
			fp = DirectoryOpened + "/" + EntryName;
		else
			fp = DirectoryOpened + EntryName;
		if ((MntList != NULL) && (MntList->MountCheck (fp) == TRUE))
			continue;
		if (DirectoryOpened == "/") {
			if ((EntryName == "proc") || (EntryName == "dev")
					|| (EntryName == "sys"))
				continue;
		}
		struct stat Stat;
		struct stat *p_Stat = &Stat;

		if (lstat (fp.c_str (), p_Stat) == 0) {
			if ((S_ISDIR (Stat.st_mode)) && !(S_ISLNK (Stat.st_mode))) {
				CountDirs++;
			}
		}
	}
	return CountDirs;
}

void FilesInDir::rewind ()
{
	rewinddir (Dir);
}

int FilesInDir::NextDir (string & Namein)
{
	Namein = "";
	int done = FALSE;
	int found = FALSE;

	while (!done) {
		if (NULL != (DirentStruct = readdir (Dir))) {
			string EntryName = DirentStruct->d_name;

			if ((EntryName == ".") || (EntryName == ".."))
				continue;
			if (EntryName == "hdd1") {
				int x;

				x++;
			}
			string fp;

			if (DirectoryOpened != "/")
				fp = DirectoryOpened + "/" + EntryName;
			else
				fp = DirectoryOpened + EntryName;
			if ((MntList != NULL) && (MntList->MountCheck (fp) == TRUE))
				continue;
			if ((DirectoryOpened == "/") && (((EntryName == "proc") ||
																				(EntryName == "dev")
																				|| (EntryName == "sys"))))
				continue;
			struct stat Stat;
			struct stat *p_Stat = &Stat;

			if (lstat (fp.c_str (), p_Stat) == 0) {
				if ((S_ISDIR (Stat.st_mode)) && !(S_ISLNK (Stat.st_mode))) {
					LastEntry = Namein = EntryName;
					found = done = TRUE;
				}
			}
		} else {
			done = TRUE;
		}
	}															// while
	return found;
}

int FilesInDir::NextFile (string & Namein)
{
	Namein = "";
	int done = FALSE;
	int found = FALSE;

	while (!done) {
		if (NULL != (DirentStruct = readdir (Dir))) {
			string EntryName = DirentStruct->d_name;

			if ((EntryName == ".") || (EntryName == ".."))
				continue;
			struct stat Stat;
			struct stat *p_Stat = &Stat;
			string fp = DirectoryOpened + "/" + DirentStruct->d_name;

			if (lstat (fp.c_str (), p_Stat) == 0) {
				if (S_ISREG (Stat.st_mode)) {
					LastEntry = Namein = EntryName;
					found = done = TRUE;
				}
			}
		} else {
			done = TRUE;
		}
	}															// while
	return found;
}

int FilesInDir::FileSize ()
{
	struct stat Status;
	struct stat *p_Stat = &Status;
	int size = 0;

	string file_w_path = DirectoryOpened + "/" + LastEntry;

	if (lstat (file_w_path.c_str (), p_Stat) == 0) {
		size = int (Status.st_size);
	}
	return size;
}

FilesInDir::~FilesInDir ()
{
	closedir (Dir);
}
